%define nsusr nagios
%define nsgrp nagios
%define cmdusr apache
%define cmdgrp apache
%define _disable_ld_no_undefined 1
%define subrel 1

Summary:    Host/service/network monitoring program
Name:       nagios
Version:    4.0.8
Release:    %mkrel 3
License:    GPLv2
Group:      Monitoring
URL:        http://www.nagios.org/
Source0:    http://prdownloads.sourceforge.net/nagios/%{name}-%{version}.tar.gz
Source1:    %{name}.service
Source2:    %{name}.tmpfiles
Source5:    favicon.ico
Patch1:     nagios-4.0.0-conf.d.patch
Patch2:     nagios-3.4.4.no-duplicate-command-definition.patch
Patch3:     nagios-4.0.8-CVE-2016-9565.patch
Patch4:     nagios-4.0.8-CVE-2016-9566.patch
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires:   nagios-plugins
Recommends:   nagios-check_http
Recommends:   nagios-check_ssh
Recommends:   nagios-check_ping
Recommends:   nagios-check_disk
Recommends:   nagios-check_load
Recommends:   nagios-check_procs
Recommends:   nagios-check_users
Recommends:   nagios-check_swap
BuildRequires:  gd-devel
BuildRequires:  imagemagick
BuildRequires:  jpeg-devel
BuildRequires:  libtool-devel
BuildRequires:  multiarch-utils >= 1.0.3
BuildRequires:  perl-devel
Provides:	nagios-agent
Epoch:      1

%description
Nagios is a program that will monitor hosts and services on your
network. It has the ability to email or page you when a problem
arises and when a problem is resolved. Nagios is written in C and
is designed to run under Linux (and some other *NIX variants) as a
background process, intermittently running checks on various
services that you specify.

The actual service checks are performed by separate "plugin"
programs which return the status of the checks to Nagios.

This package provide core programs for nagios. The web interface,
documentation, and development files are built as separate
packages

%package    www
Summary:    Provides the HTML and CGI files for the Nagios web interface
Group:      Networking/WWW
Requires:   %{name} = %{epoch}:%{version}-%{release}
Requires:   freetype
Requires:   freetype2
Requires:   nail
Requires:   traceroute
Requires:   apache-mod_php
Epoch:      %{epoch}

%description    www
Nagios is a program that will monitor hosts and services on your network. It
has the ability to email or page you when a problem arises and when a problem
is resolved. Nagios is written in C and is designed to run under Linux (and
some other *NIX variants) as a background process, intermittently running
checks on various services that you specify.

Several CGI programs are included with Nagios in order to allow you to view the
current service status, problem history, notification history, and log file via
the web. This package provides the HTML and CGI files for the Nagios web
interface. In addition, HTML documentation is included in this package

%package    devel
Group:      Development/C
Summary:    Provides include files that Nagios-related applications may compile against
Epoch:      %{epoch}

%description    devel
Nagios is a program that will monitor hosts and services on your network. It
has the ability to email or page you when a problem arises and when a problem
is resolved. Nagios is written in C and is designed to run under Linux (and
some other *NIX variants) as a background process, intermittently running
checks on various services that you specify.

This package provides include files that Nagios-related applications may
compile against.

%prep
%setup -q 
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%build
%serverbuild

export CFLAGS="$CFLAGS -fPIC"
export CXXFLAGS="$CXXFLAGS -fPIC"
export FFLAGS="$FFLAGS -fPIC"
%configure2_5x \
    --with-httpd-conf=%{_webappconfdir} \
    --with-checkresult-dir=/var/spool/nagios/checkresults \
    --with-temp-dir=/tmp \
    --exec-prefix=%{_sbindir} \
    --bindir=%{_sbindir} \
    --sbindir=%{_libdir}/nagios/cgi \
    --libexecdir=%{_libdir}/nagios/plugins \
    --datadir=%{_datadir}/nagios \
    --sysconfdir=%{_sysconfdir}/nagios \
    --localstatedir=/var/log/nagios \
    --with-lockfile=/run/nagios/nagios.pid \
    --with-mail=/bin/mail \
    --with-nagios-user=%{nsusr} \
    --with-nagios-group=%{nsgrp} \
    --with-command-user=%{cmdusr} \
    --with-command-grp=%{cmdgrp} \
    --with-cgiurl=/nagios/cgi-bin \
    --with-htmurl=/nagios \
    --with-gd-lib=%{_libdir} \
    --with-gd-inc=%{_includedir}

# bug
perl -pi -e "s|/var/log/nagios/spool/checkresults|/var/spool/nagios/checkresults|g" include/locations.h

%make all

pushd contrib
    make convertcfg
    make daemonchk.cgi
popd

%install
make \
    DESTDIR=%{buildroot} \
    BINDIR=%{_sbindir} \
    CFGDIR=%{_sysconfdir}/nagios \
    CGIDIR=%{_libdir}/nagios/cgi \
    COMMAND_OPTS="" \
    HTMLDIR=%{_datadir}/nagios/www \
    INIT_OPTS="" \
    INSTALL=install \
    INSTALL_OPTS="" \
    LOGDIR=/var/log/nagios \
    STRIP=/bin/true \
    install \
    install-devel \
    install-config

pushd contrib
make \
    DESTDIR=%{buildroot} \
    BINDIR=%{_sbindir} \
    CFGDIR=%{_sysconfdir}/nagios \
    CGIDIR=%{_libdir}/nagios/cgi \
    COMMAND_OPTS="" \
    HTMLDIR=%{_datadir}/nagios/www \
    INIT_OPTS="" \
    INSTALL=install \
    INSTALL_OPTS="" \
    LOGDIR=/var/log/nagios \
    install
popd

# fix strange perms
find %{buildroot}%{_datadir}/nagios -type d | xargs chmod 755
find %{buildroot}%{_datadir}/nagios -type f | xargs chmod 644
find %{buildroot}%{_sysconfdir}/nagios -type d | xargs chmod 755
find %{buildroot}%{_sysconfdir}/nagios -type f | xargs chmod 644
chmod 755 \
    %{buildroot}%{_libdir}/nagios/cgi/* \
    %{buildroot}%{_sbindir}/*

# fix docs
cp sample-config/README README.sample-config
cp sample-config/template-object/README README.template-object

# install headers
install -d -m 755 %{buildroot}%{_includedir}/nagios
install -m 644 include/locations.h %{buildroot}%{_includedir}/nagios/
%multiarch_includes %{buildroot}%{_includedir}/nagios/locations.h

install -d -m 755 %{buildroot}/var/spool/nagios/checkresults

# add a placeholder directory for all object configuration files
install -d -m 755 %{buildroot}%{_sysconfdir}/nagios/conf.d

# transfert relevant files from sample configuration there
for file in commands contacts timeperiods templates localhost; do
    mv %{buildroot}%{_sysconfdir}/nagios/objects/$file.cfg \
        %{buildroot}%{_sysconfdir}/nagios/conf.d
done

# drop others
rm -rf %{buildroot}%{_sysconfdir}/nagios/objects

# compatibility symlink
pushd  %{buildroot}%{_sysconfdir}/nagios
    ln -s conf.d plugins.d
popd

# adapt default configuration
perl -pi \
    -e 's|^check_for_updates=1|check_for_updates=0|;' \
    -e 's|^#query_socket=|query_socket=|;' \
    -e 's|=/var/log/nagios/rw|=/var/spool/nagios|;' \
    %{buildroot}%{_sysconfdir}/nagios/nagios.cfg

perl -pi \
    -e 's|^physical_html_path=.*|physical_html_path=%{_datadir}/nagios/www|;' \
    %{buildroot}%{_sysconfdir}/nagios/cgi.cfg
    

# systemd
install -D -m 644 %{SOURCE1} %{buildroot}%{_unitdir}/nagios.service
install -D -m 644 %{SOURCE2} %{buildroot}%{_prefix}/lib/tmpfiles.d/nagios.conf

# apache configuration
install -d -m 755 %{buildroot}%{_webappconfdir}
cat > %{buildroot}%{_webappconfdir}/%{name}.conf <<EOF
# Nagios Apache configuration

ScriptAlias /%{name}/cgi-bin %{_libdir}/%{name}/cgi

<Directory %{_libdir}/%{name}/cgi>
    Options ExecCGI
    Require all granted
</Directory>

Alias /%{name} %{_datadir}/%{name}/www

<Directory %{_datadir}/%{name}>
    Require all granted
</Directory>
EOF

# install and fix event handlers
install -d -m 755 %{buildroot}%{_libdir}/nagios/plugins/eventhandlers
pushd contrib/eventhandlers/
install -m 755 \
    disable_active_service_checks \
    disable_notifications \
    enable_active_service_checks \
    enable_notifications \
    submit_check_result \
    distributed-monitoring/obsessive_svc_handler \
    distributed-monitoring/submit_check_result_via_nsca \
    redundancy-scenario1/handle-master-host-event \
    redundancy-scenario1/handle-master-proc-event \
    %{buildroot}%{_libdir}/nagios/plugins/eventhandlers
popd

find %{buildroot}%{_libdir}/nagios/plugins/eventhandlers -type f | \
    xargs perl -pi \
    -e 's|/usr/local/nagios/var/rw/|/var/spool/nagios/|;' \
    -e 's|/usr/local/nagios/libexec/eventhandlers|%{_libdir}/nagios/plugins/eventhandlers|g;' \
    -e 's|/usr/local/nagios/libexec/send_nsca|%{_libdir}/nagios/plugins/send_nsca|g;' \
    -e 's|/usr/local/nagios/test/var|/var/log/nagios|g;' \
    -e 's|/usr/local/nagios/etc/send_nsca.cfg|%{_sysconfdir}/nagios/send_nsca.cfg|g;' \
    -e 's|printfcmd="/bin/printf"|printfcmd="/usr/bin/printf"|;'

# install the favicon.ico
install -m 644 %{SOURCE5} %{buildroot}%{_datadir}/nagios/www

# automatic reloading for new plugins
install -d %buildroot%{_var}/lib/rpm/filetriggers
cat > %buildroot%{_var}/lib/rpm/filetriggers/nagios.filter << 'EOF'
^.%{_sysconfdir}/nagios/plugins.d/.*\.cfg$
^.%{_sysconfdir}/nagios/conf.d/.*\.cfg$
EOF
cat > %buildroot%{_var}/lib/rpm/filetriggers/nagios.script << 'EOF'
#!/bin/sh
systemctl reload-or-try-restart nagios.service
EOF
chmod 755 %buildroot%{_var}/lib/rpm/filetriggers/nagios.script

%pretrans
# prevent symlink creation failure on update
if [ -d /etc/nagios/plugins.d -a ! -L /etc/nagios/plugins.d ]; then
    if [ ! -d /etc/nagios/conf.d ]; then
        mkdir -p /etc/nagios/conf.d
    fi
    mv -f /etc/nagios/plugins.d/* /etc/nagios/conf.d 2>/dev/null
    rmdir /etc/nagios/plugins.d
fi

%pre
%_pre_useradd %{nsusr} /var/log/nagios /bin/sh
%{_bindir}/gpasswd -a %{cmdusr} %{nsgrp} >/dev/null 2>&1 || :

%post
%_tmpfilescreate %{name}
%_post_service %{name}

%preun
%_preun_service %{name}

%postun
%_postun_userdel %{nsusr}

%files
%doc Changelog INSTALLING LEGAL README UPGRADING
%doc sample-config/mrtg.cfg
%{_unitdir}/nagios.service
%{_prefix}/lib/tmpfiles.d/nagios.conf
%{_sbindir}/*
%dir %{_sysconfdir}/nagios
%dir %{_sysconfdir}/nagios/conf.d
%{_sysconfdir}/nagios/plugins.d
%config(noreplace) %{_sysconfdir}/nagios/*.cfg
%config(noreplace) %{_sysconfdir}/nagios/conf.d/*.cfg
%attr(-,%{nsusr},%{nsgrp}) %dir /var/log/nagios
%attr(-,%{nsusr},%{nsgrp}) %dir /var/log/nagios/archives
%attr(2775,%{nsusr},%{cmdgrp}) %dir /var/spool/nagios
%attr(-,%{nsusr},%{nsgrp}) %dir /var/spool/nagios/checkresults
%{_libdir}/nagios/plugins/eventhandlers
%{_var}/lib/rpm/filetriggers/nagios.*

%files www
%config(noreplace) %{_webappconfdir}/nagios.conf
%{_libdir}/nagios/cgi
%{_datadir}/nagios/www

%files devel
%multiarch %{multiarch_includedir}/nagios/locations.h
%{_includedir}/nagios
%{_libdir}/libnagios.a


%changelog
* Sat Dec 31 2016 guillomovitch <guillomovitch> 1:4.0.8-3.1.mga5
+ Revision: 1078882
- backport upstream patches to fix CVE 2016-9565 and CVE 2016-9565 (bug #19989)

* Mon Feb 16 2015 oden <oden> 1:4.0.8-2.mga5
+ Revision: 815156
- rebuilt for libgd-2.1.1

* Sun Nov 09 2014 guillomovitch <guillomovitch> 1:4.0.8-1.mga5
+ Revision: 796132
- new version 4.0.8

* Wed Oct 15 2014 umeabot <umeabot> 1:4.0.7-3.mga5
+ Revision: 742428
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1:4.0.7-2.mga5
+ Revision: 682762
- Mageia 5 Mass Rebuild

  + tv <tv>
    - s/uggests:/Recommends:/

* Mon Jun 23 2014 guillomovitch <guillomovitch> 1:4.0.7-1.mga5
+ Revision: 638798
- new version 4.0.7

* Mon Apr 21 2014 luigiwalser <luigiwalser> 1:4.0.2-2.mga5
+ Revision: 617340
- add patch from icinga via opensuse to fix CVE-2014-1878

* Tue Dec 31 2013 guillomovitch <guillomovitch> 1:4.0.2-1.mga4
+ Revision: 563550
- new version 4.0.2
- add upstream patch to fix CVE-2013-7108 and CVE-2013-7205

* Tue Nov 12 2013 dlucio <dlucio> 1:4.0.1-1.mga4
+ Revision: 550860
- 4.0.1
- setup directory fix

* Mon Oct 21 2013 umeabot <umeabot> 1:4.0.0-2.mga4
+ Revision: 539497
- Mageia 4 Mass Rebuild

* Sun Oct 06 2013 guillomovitch <guillomovitch> 1:4.0.0-1.mga4
+ Revision: 492345
- new version 4.0
- reduce the default sample configuration for sake of readability
- use more generic conf.d instead of plugins.d as default drop-in directory
- fix tempfile creation at package installation

* Sun Sep 29 2013 guillomovitch <guillomovitch> 1:3.5.1-2.mga4
+ Revision: 489245
- drop unwanted and uselessly complex authentication from default apache configuration
- drop uselessly complex pre-execution configuration hack from systemd service
- reintroduce standard %%{_webappconfdir} macro

* Sun Sep 01 2013 guillomovitch <guillomovitch> 1:3.5.1-1.mga4
+ Revision: 473998
- new version

* Thu Aug 01 2013 alien <alien> 1:3.5.0-3.mga4
+ Revision: 462396
- Use BasicAuth by default
- split off localhost checks into subpackage (it conflicts with check_mk-localhost)
- move the apache webapp conf to the correct location
- implement reloading the nagios service
- hack a way to have a config directory for broker modules
- allow the nagiosadmin user admin access
- put the localhost config in the right place

* Mon May 27 2013 oden <oden> 1:3.5.0-2.mga4
+ Revision: 428750
- rebuilt against libgd.so.3

* Thu May 23 2013 guillomovitch <guillomovitch> 1:3.5.0-1.mga4
+ Revision: 424811
- new version

* Fri Feb 15 2013 dlucio <dlucio> 1:3.4.4-4.mga3
+ Revision: 398589
- New provides to let NRPE or Nagios be choosen for plugins

* Thu Feb 07 2013 guillomovitch <guillomovitch> 1:3.4.4-3.mga3
+ Revision: 395124
- drop command definition from default configuration to avoid conflict with definitions found in plugin packages
- soft dependency on plugins used in default configuration (#8986)

* Wed Feb 06 2013 guillomovitch <guillomovitch> 1:3.4.4-2.mga3
+ Revision: 394811
- switch group to monitoring

* Sun Jan 27 2013 guillomovitch <guillomovitch> 1:3.4.4-1.mga3
+ Revision: 392788
- new version

* Sat Jan 12 2013 umeabot <umeabot> 1:3.4.3-2.mga3
+ Revision: 360674
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Dec 10 2012 guillomovitch <guillomovitch> 1:3.4.3-1.mga3
+ Revision: 329333
- new version

* Wed Sep 05 2012 guillomovitch <guillomovitch> 1:3.4.1-8.mga3
+ Revision: 288650
- cleanup installation process, and ensure standard perms

* Fri Aug 24 2012 guillomovitch <guillomovitch> 1:3.4.1-7.mga3
+ Revision: 283391
- make webapp configuration file compliant with apache 2.4

* Thu Aug 23 2012 guillomovitch <guillomovitch> 1:3.4.1-6.mga3
+ Revision: 283355
- don't ship /var/run/nagios

* Fri Jul 06 2012 guillomovitch <guillomovitch> 1:3.4.1-5.mga3
+ Revision: 268427
- fix rpm filetrigger to use systemctl instead of systemd init script

* Thu Jun 07 2012 guillomovitch <guillomovitch> 1:3.4.1-4.mga3
+ Revision: 256947
- fix www package dependencies

* Tue Jun 05 2012 guillomovitch <guillomovitch> 1:3.4.1-3.mga3
+ Revision: 255980
- don't turn off default syslog log duplication
- use /usr/lib/tmpfiles.d for temp files definitions

* Tue Jun 05 2012 guillomovitch <guillomovitch> 1:3.4.1-2.mga3
+ Revision: 255896
- add systemd support
- drom sysinit support
- drop old mergecfg script

* Mon Jun 04 2012 guillomovitch <guillomovitch> 1:3.4.1-1.mga3
+ Revision: 254077
- new version
- merge default-theme package into www package
- add mod_php dependency for www package

* Sun Sep 18 2011 misc <misc> 1:3.3.1-2.mga2
+ Revision: 145053
- fix init script lsb keyword

  + dmorgan <dmorgan>
    - Change apache-conf require

  + guillomovitch <guillomovitch>
    - the theme package is noarch
    - patch3: fix issue with rss files installation
    - use standard %%_pre_useradd macro
    - more spec cleanup
    - drop useless XDG menu
    - new version
    - spec cleanup
    - drop README.mdv, information provided there is just about packaging changes
    - drop obsolete migration %%post scripts
    - drop useless external configuration package
    - no need for arbitrary default configuration structure, let the user do it

* Thu Mar 03 2011 ennael <ennael> 1:3.2.3-2.mga1
+ Revision: 63044
- clean spec file
- imported package nagios

